SIGCHLD handler not working correctly

A

Asfand Yar Qazi

Hi,

Here's some test code that demonstrates what I'm doing:

----------------------cut here----------------------

#!/usr/bin/ruby -w

trap_quit = lambda { |sig|
signame = Signal.list.find {|k, v| v == sig }[0]
STDERR.puts("Trapping signal #{signame}")
}

huphandler = inthandler = termhandler = chldhandler = nil
huphandler = trap("HUP", &trap_quit)
inthandler = trap("INT", &trap_quit)
termhandler = trap("TERM", &trap_quit)

cmd_exitstatus = nil

chldhandler = trap("CHLD") {
STDERR.puts("Trapping signal CHLD")
begin
# tmppid, status = Process.wait2(cmdpid)
tmppid = Process.wait
status = $?
cmd_exitstatus = status.exitstatus
STDERR.puts("Process::Status => " + status.inspect)
STDERR.puts("exitstatus => " + cmd_exitstatus.inspect)
if ! status.exited?
raise "ARGH! The child has not exited yet!"
end
rescue Errno::ECHILD => e
STDERR.puts("Command failed - probably ok? #{e.inspect}")
# bah, ignore it, just means a command failed
end
}

cmdpid = fork {
begin
exec("dd", "if=/dev/zero", "of=/tmp/zerofile1.asdfsdf",
"bs=1", "count=333000000")
rescue Errno::ENOENT => e
STDERR.puts e.message
exit 127
end
}

while(cmd_exitstatus.nil?)
sleep 1
STDOUT.puts "still going..."
STDOUT.flush
end

----------------------cut here----------------------

To see the problem, run the command, then press CTRL-C while it's
running. It will say "ARGH! The child has not exited yet!"

Inside the CHLD handler, exitstatus should be the valid exit status of
the child process. However, it is nil. This is really really bad,
because it seems to imply that the child signal, which is meant to be
caught when a child exits, is being called while the child has NOT exited.

Anyone tell me what I'm doing wrong?

Thanks
 
L

Lionel Bouton

Asfand Yar Qazi wrote the following on 15.12.2007 09:30 :
--

To see the problem, run the command, then press CTRL-C while it's
running. It will say "ARGH! The child has not exited yet!"

Inside the CHLD handler, exitstatus should be the valid exit status of
the child process.

If I'm not mistaken, there's none because the child didn't call exit.
However, it is nil. This is really really bad,
because it seems to imply that the child signal, which is meant to be
caught when a child exits, is being called while the child has NOT exited.

Looking at Process::Status#exited? documentation it seems it only
returns true if the process actually exited on its own. Here dd dies
because of a SIGINT (calling $?.signaled? returns true).

I'm not familiar with the signal handling details, so the following is
no more than an educated guess.
I believe that depending on the actual implementation of the signal
handler you can get different reactions to a signal relative to exit
status. Either:
- the program aborts *in the signal handler* and don't return an exit
status,
- the signal handler is only used to modify internal structures and
doesn't abort the program right away. The normal course of the program
only checks for the exit condition so you get a delayed "normal" exit
controlled by a signal. In this case you get an exit status.

Lionel
 

Ask a Question

Want to reply to this thread or ask your own question?

You'll need to choose a username for the site, which only take a couple of moments. After that, you can post your question and our members will help you out.

Ask a Question

Similar Threads

[ANN] open4-0.7.0 0
[ANN] open4-0.6.0 0
[ANN] open4-0.8.0 2
[ANN] open4-0.9.0 0
[ANN] open4-0.9.2 0
[ANN] open4-0.5.0 0
[ANN] open4-0.5.1 0
OneAtATime 0

Members online

Forum statistics

Threads
473,744
Messages
2,569,482
Members
44,901
Latest member
Noble71S45

Latest Threads

Top